' utf8decode.VBS V1.06 (C) yoshioka.teruo@nifty.com 2006-05-31
' utf8decode.VBS decodes from UTF-8
' Usage: Start utf8decode.VBS [/a|/w] files...
' Usage: CScript.EXE //NoLogo utf8decode.VBS [<input] [>output]

Option Explicit
Dim Lines
Dim Page
Dim Odd
Dim fUnicode
Dim wShell
Dim fso
Dim args
Dim arg
Dim File
Dim tPath
Const vbHide=0
Dim Command
Dim rc
Dim FileName
Dim oPath
Dim n
Dim tName

Const Usage="Usage: Start utf8decode.VBS [/a|/w] files..."

Lines=Array()
fUnicode=False

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

args=Array()
For Each arg In WScript.Arguments
  If Left(arg,1)="/" Then
    Select Case LCase(arg)
    Case "/a" fUnicode=False
    Case "/w" fUnicode=True
    Case Else
      WScript.Echo "Invalid Option Argument :",arg,vbLf & Usage
      WScript.Quit
    End Select
  Else
    ReDim Preserve args(UBound(args)+1)
    args(UBound(args))=arg
  End If
Next

For Each arg In args
  Set File=fso.GetFile(arg)
  tPath=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetTempName())
  Odd=CBool(File.Size Mod 2)
  If Odd Then
    fso.CreateTextFile(tPath).Write Chr(&HFF) & Chr(&HFE) & Chr(0)
  Else
    fso.CreateTextFile(tPath).Write Chr(&HFF) & Chr(&HFE)
  End If
    Command="%COMSPEC% /CCOPY /B """ & tPath & """+""" & File.Path & """ """ &  tPath & """"
'    rc=wShell.Run(Command,1,True)
    rc=wShell.Run(Command,vbHide,True)
'    WScript.Echo rc,command
  FileName=File.Name
  oPath=fso.BuildPath(fso.GetParentFolderName(File.Path),fso.GetTempName())
  Call DecodeFile(fso.OpenTextFile(tPath,,,True),fso.CreateTextFile(oPath,,fUnicode))
  fso.DeleteFile(tPath)

  For n=1000 To 1999
    tName=fso.GetBaseName(FileName) & "." & Right(n,3)
    Call Rename(File,tName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next
  WScript.Echo FileName & " -> " & tName

  Set File=fso.GetFile(oPath)
  Call Rename(File,FileName)
  If Err<>0  Then
    WScript.Echo Err.Number & ":" & Err.Description
    WScript.Quit
  End If
Next
If UBound(args)=-1 Then
  If UCase(fso.GetBaseName(WScript.FullName))="CSCRIPT" Then
    Call DecodeFile(fso.GetStandardStream(0,True),fso.GetStandardStream(1,fUnicode))
  Else
    WScript.Echo Usage
    WScript.Quit
  End If
End If
WScript.Quit

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Sub DecodeFile(StdIn,StdOut)
Dim code
Dim code1
Dim code2
Dim code3
Dim k,buf

If StdIn.AtEndOfStream Then Exit Sub
buf=ReadAll(StdIn)
For k=1-Odd To LenB(buf)
  code=AscB(MidB(buf,k,1))
  If 0<=code And code<128 Then
    StdOut.Write Chr(code)
  ElseIf 128+64<=code And code<128+64+32 Then
    code1=code
    k=k+1
    code2=AscB(MidB(buf,k,1))
    code=(code1 And &H1F) * 64 + (code2 And &H3F)
    If fUnicode Then
      StdOut.Write ChrW(code)
    ElseIf Chr(Asc(ChrW(code)))=ChrW(code) Then
      StdOut.Write ChrW(code)
    Else
      Select Case code
      Case &HA0 StdOut.Write " "
      Case &HA9 StdOut.Write "(C)"
      Case &HAE StdOut.Write "(R)"
      Case Else
        StdOut.Write Escape(ChrW(code))
        Echo "Invalid UTF-8 Code : " & Escape(ChrW(code)) & " " & Right(Hex(code1+256),2) & Right(Hex(code2+256),2)
      End Select
    End If
  ElseIf 128+64+32<=code And code<128+64+32+16 Then
    code1=code
    k=k+1
    code2=AscB(MidB(buf,k,1))
    k=k+1
    code3=AscB(MidB(buf,k,1))
    code=(code1 And &H0F) * 16 * 256 + (code2 And &H3F) * 64 + (code3 And &H3F)
    If Chr(Asc(ChrW(code)))=ChrW(code) Then
      StdOut.Write ChrW(code)
    Else
      Select Case code
      Case &HFEFF&	'BOM
      Case &H2013 StdOut.Write "-"
      Case &H2022 StdOut.Write "+"
      Case &H02DC StdOut.Write "~"
      Case &H2122 StdOut.Write "TM"
      Case Else
        StdOut.Write Escape(ChrW(code))
        Echo "Invalid UTF-8 Code : " & Escape(ChrW(code)) & " " & Right(Hex(code1+256),2) & Right(Hex(code2+256),2) & Right(Hex(code3+256),2)
      End Select
    End If
  Else
    StdOut.Write Escape(ChrW(code))
    Echo "Invalid UTF-8 Code : " & Escape(ChrW(code)) & " " & Right(Hex(code+256),2)
  End If
Next
EchoUp
End Sub

Sub EchoUp()
If UBound(Lines)>-1 Then
  If vbCancel=MsgBox(Join(Lines,vbLf),vbOkCancel,"page " & Page+1) Then WScript.Quit
  Lines=Array()
  Page=0
End If
End Sub

Sub Echo(str)
Const MaxLineCount=20
On Error Resume Next
WScript.StdOut.WriteLine str
If Err=0 Then Exit Sub
If UBound(Lines)+1=MaxLineCount Then
  If vbCancel=MsgBox(Join(Lines,vbLf),vbOkCancel,"page " & Page+1) Then WScript.Quit
  Lines=Array()
  Page=Page+1
End If
Push Lines,str
End Sub

Function ReadAll(StdIn)
Dim Block
Block=Array()
Do While Not StdIn.AtEndOfStream
  Push Block,StdIn.Read(4096)
Loop
ReadAll=Join(Block,"")
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
